## sather-1.3-beta-7.tar.bz2

=== Makefile ===
#------------------------------->  Makefile  <--------------------------------#
#- Copyright (C) 1994 by International Computer Science Institute            -#
#- This file is part of the GNU Sather package. It is free software; you may -#
#- redistribute  and/or modify it under the terms of the  GNU General Public -#
#- License (GPL)  as  published  by the  Free  Software  Foundation;  either -#
#- version 2 of the license, or (at your option) any later version.          -#
#- This  program  is distributed  in the  hope that it will  be  useful, but -#
#- WITHOUT ANY WARRANTY without even the implied warranty of MERCHANTABILITY -#
#- or FITNESS FOR A PARTICULAR PURPOSE. See Doc/GPL for more details.        -#
#- The license text is also available from:  Free Software Foundation, Inc., -#
#- 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                     -#
#------------->  Please email comments to <bug-sather@gnu.org>  <-------------#

###############################################################################
# Be sure to read the file Doc/Installation!
# You may need to set some variables in System/Common/CONFIG.proto
# to be appropriate to your system.
# Also make sure to adjust the paths in System/Platforms/X/Platform.module
# and System/Platforms/tcltk/Platform.module
###############################################################################

export SATHER_HOME=$(shell pwd)
export LOCALE=en_NZ
export SATHER_ENV=$(SATHER_HOME)/resources/$(LOCALE)/bin/LIBCHARS
unexport SATHER_LIBRARY

###############################################################################
# include configuration information

include $(SATHER_HOME)/config.default

##############################################################################
# construct the needed variables

SACOMP          =bin/sacomp
SACOMP_BOOT     =bin/sacomp-boot
SACOMP_BOOT_CODE=bin/sacomp-boot.code
SACOMP_DEBUG    =bin/sacomp-debug
SACOMP_PROFILE  =bin/sacomp-profile
SABROWSE        =bin/sabrowse

CS_OPT        =-verbose -O_fast -O_no_move_while -O_no_hoist_const -O_no_cse -only_reachable -pretty
CS_OPT_DEBUG  =-verbose -chk -debug -debug_deterministic -debug_no_backtrace
CS_OPT_PROFILE=-verbose -only_reachable -optimize -C_flag -pg

################################ DEPENDENCIES #################################

# The compiler which ends up in bin/ is the "fast" executable,
# which means that checking is turned off and optimizations are on.

# Some makes can't expand glob syntax with more than one *, so
# only specify one directory to expand instead of listing all of them.
# Watch out for this if you are modifying the compiler.

# This runs the C compiles after the Sather compiler instead of at
# the same time, to ease installation for those with small VM.

default: $(SACOMP)

$(SACOMP): $(SACOMP_BOOT)
	@echo "**** Creating C for installation compiler *****"
#	$(SACOMP_BOOT) $(CS_OPT) sacomp/sacomp.module -o $(SACOMP) -only_C
# Ugly, but the clean solution in sacomp means some work...:
	cp platforms/cygwin/Platform.empty platforms/cygwin/Platform.module
	cd bin ; ../$(SACOMP_BOOT) $(CS_OPT) ../sacomp/sacomp.module -o ../$(SACOMP) -only_C
	@echo "***** Compiling C for installation compiler *****"
	$(MAKE) -C $(SACOMP).code
	cp platforms/cygwin/Platform.run platforms/cygwin/Platform.module
# CFLAGS="-I. -g"

boot: $(SACOMP_BOOT)

optional: browser gui-server

browser: $(SACOMP_BOOT)
	@echo "***** Creating C for Browser *****"
	$(SACOMP_BOOT) $(CS_OPT) auxiliaries/sabrowse/sabrowse.module -o $(SABROWSE) -only_C
	@echo "***** Compiling C for Browser *****"
	$(MAKE) -C $(SABROWSE).code

gui-server: $(SACOMP)
	$(MAKE) -C auxiliary/sagui-server

debug: $(SACOMP_BOOT)
	cd bin ; ../$(SACOMP_BOOT) $(CS_OPT_DEBUG) ../sacomp/sacomp.module -o $(SACOMP_DEBUG) -only_C
	$(MAKE) -C $(SACOMP_DEBUG).code

profile: $(SACOMP_BOOT)
	cd bin ; ../$(SACOMP) $(CS_OPT_PROFILE) ../sacomp/sacomp.module -o $(SACOMP_PROFILE) -only_C
	$(MAKE) -C $(SACOMP_PROFILE).code

$(SACOMP_BOOT): system
	@echo; echo "Making boot compiler..." ; echo
	$(LN) ../$(BOOT_PLATFORM)/header.h platforms/BOOT/header.h
	$(MAKE) -C $(SACOMP_BOOT_CODE) $(MAKE_OPT_BOOT)

# The rule for System/Common/CONFIG also makes the serial libraries,
# as well as making any platforms.

system:
	for i in $(SATHER_HOME)/resources/*/bin ; do \
	  $(RM) $$i/LIBCHARS ;                          \
	  $(LN) $(LIBCHARS_VERSION) $$i/LIBCHARS ;   \
	done

	$(MAKE) -C system

	for i in `echo "BOOT",$(PLATFORMS) | tr , \ `; do		\
	  echo "Making platform $$i..." ;				\
	  $(MAKE) -C platforms/$$i ;					\
	done


info:
	cd emacs && makeinfo sather.texinfo
	cd emacs && makeinfo sather-tutorial.texinfo
	cd emacs && makeinfo sather-mode.texinfo

.PHONY: boot optional browser gui-server debug profile system info \
test clean-unneeded clean info

################################### TESTING ###################################

test:
	$(MAKE) -C test

################################### CLEANING ##################################

clean:
	$(MAKE) -C system clean
	$(MAKE) -C test clean
	$(MAKE) -C auxiliaries/sagui-server clean

	for i in platforms/* ; do					\
	  if [ -f $$i/Makefile ] ; then $(MAKE) -C $$i clean ; fi	\
	done;

	$(RM) -r $(SACOMP).code $(SABROWSE).code
	$(RM) -r $(SACOMP_PROFILE).code $(SACOMP_DEBUG).code
	$(RM) $(SACOMP_BOOT).code/*.o
	$(RM) $(SACOMP) $(SACOMP_BOOT) $(SABROWSE)
	$(RM) $(SACOMP_PROFILE) $(SACOMP_DEBUG)

	$(RM) $(SATHER_HOME)/resources/*/bin/LIBCHARS

	$(RM) config.platform

	$(RM) emacs/*.elc
	$(RM) emacs/*.info emacs/*.info??

	[ -x debian/rules ] && debian/rules clean-safe
