=== auxiliaries/sagui-server/Makefile ===
#------------------------------->  Makefile  <--------------------------------#
#- Copyright (C) 199x by International Computer Science Institute            -#
#- This file is part of the GNU Sather package. It is free software; you may -#
#- redistribute  and/or modify it under the terms of the  GNU General Public -#
#- License (GPL)  as  published  by the  Free  Software  Foundation;  either -#
#- version 2 of the license, or (at your option) any later version.          -#
#- This  program  is distributed  in the  hope that it will  be  useful, but -#
#- WITHOUT ANY WARRANTY without even the implied warranty of MERCHANTABILITY -#
#- or FITNESS FOR A PARTICULAR PURPOSE. See Doc/GPL for more details.        -#
#- The license text is also available from:  Free Software Foundation, Inc., -#
#- 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                     -#
#------------->  Please email comments to <bug-sather@gnu.org>  <-------------#

default: all

# Generate the server end for the dual process gui
export SATHER_HOME=$(shell cd ../..;pwd)
include $(SATHER_HOME)/config.default

CS_OPT=-verbose -only_reachable -pretty -chk
SACOMP=$(SATHER_HOME)/bin/sacomp

SAGUI_SERVER=$(SATHER_HOME)/bin/sagui-server

all: $(SAGUI_SERVER)

$(SAGUI_SERVER):
	$(SACOMP) sagui-server.module -o $(SAGUI_SERVER) $(CS_OPT) -only_C
	$(MAKE) -C $(SAGUI_SERVER).code

clean:
	$(RM) -R $(SAGUI_SERVER) $(SAGUI_SERVER).code
