=== bin/sacomp-boot.code/Makefile ===
SHOME  =../..
CFLAGS = -I.  -O  -I../system
CC     =gcc
HDR    =sather.h tags.h
LIBS   = -lgc -lm
CS     =sacomp-boot
OBJ    = a_stackA_STACK2014955575.o am_outAM_OUT1363671444.o am_outAM_OUT1363671444x.o arefFSETAM_ROU1518004496.o arefFSETIMMUTA2116029667.o arefFSETTUPSIG268064465.o arrayARRAYAM_I1084914261.o arrayARRAYTUPI1927875024.o as_outAS_OUT1429002792.o as_outAS_OUT1429002792x.o cgenCGEN1354269066.o cgenCGEN1354269066x.o cgenCGEN1354269066xx.o cgenCGEN1354269066xxx.o cgenCGEN1354269066xxxx.o cgenCGEN1354269066xxxxx.o cgenCGEN1354269066xxxxxx.o cgenCGEN1354269066xxxxxxx.o cgenCGEN1354269066xxxxxxxx.o cgenCGEN1354269066xxxxxxxxx.o cgenCGEN1354269066xxxxxxxxxx.o code_fileCODE_372141741.o configCONFIG_R422014871.o constAM_VOID_C1458622435.o cs_optionsCS_O301318552.o cs_optionsCS_O301318552x.o cursorAM_CURSO1314676474.o cursorAM_CURSO1314676474x.o cursorAM_CURSO1314676474xx.o cursorAM_CURSO1314676474xxx.o dispatch.o eltELT742463773.o elt_algELT_ALG1548486913.o elt_algELT_ALG241706736.o elt_algELT_ALG433952755.o elt_algELT_ALG656599769.o elt_algELT_ALG987448979.o flistFLISTAM_C1171004157.o flistFLISTTUPA253333040.o fmapFMAPAM_ROU1000508936.o fmapFMAPSTRFSE258056667.o fmapFMAPdTPCOD1051074108.o generate_amGEN60284023.o get_optionsCOD183550016.o globals.o get_optionsCOD183550016x.o implIMPL_CREAT99472218.o inlineINLINE_I1557365391.o intiINTI1462257232.o layoutCLASS_LA1330944056.o mangleMANGLE1705139666.o mangleNAMESPAC760510184.o o_localOPT_LOC907909712.o o_localOPT_LOC907909712x.o optimizeOPT_CO1177876774.o optimizeOPT_IT1193060919.o parsePARSER311504339.o parsePARSER311504339x.o parsePARSER311504339xx.o parsePARSER311504339xxx.o parsePARSER311504339xxxx.o progPROG_AS_TB824135997.o scanSCANNER1990933774.o side_effectSE_411721069.o strings.o stringsx.o stringsxx.o system.o stmtAM_FORK_ST1674905658.o tpTP_BUILTIN1142074570.o tpTP_ITER145455607.o transTRANS2123847391.o transTRANS2123847391x.o transTRANS2123847391xx.o transTRANS2123847391xxx.o transTRANS2123847391xxxx.o tupTUPAM_CURSO1313579705.o unbox.o unixUNIX1766692.o runtime.o
OTHER  =


../$(CS): LINK_OPTIONS $(OBJ) $(HDR)
	$(CC) $(CFLAGS) -o ../$(CS) $(OBJ) $(OTHER) $(LIBS)

$(OBJ): COMPILE_OPTIONS $(HDR)

runtime.o: ../../system/old-runtime/runtime.c COMPILE_OPTIONS $(HDR)
	$(CC) $(CFLAGS) -c ../../system/old-runtime/runtime.c
