=== platforms/solaris/i386_smp_at/Makefile ===
#------------------------------->  Makefile  <--------------------------------#
#- Copyright (C) 199x by International Computer Science Institute            -#
#- This file is part of the GNU Sather package. It is free software; you may -#
#- redistribute  and/or modify it under the terms of the  GNU General Public -#
#- License (GPL)  as  published  by the  Free  Software  Foundation;  either -#
#- version 2 of the license, or (at your option) any later version.          -#
#- This  program  is distributed  in the  hope that it will  be  useful, but -#
#- WITHOUT ANY WARRANTY without even the implied warranty of MERCHANTABILITY -#
#- or FITNESS FOR A PARTICULAR PURPOSE. See Doc/GPL for more details.        -#
#- The license text is also available from:  Free Software Foundation, Inc., -#
#- 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                     -#
#------------->  Please email comments to <bug-sather@gnu.org>  <-------------#

all: 
	@ echo Making Active Threads library for Brahma
	$(MAKE) -C ../../../system/activethreads i386-solaris
	@ echo Making Brahma at_solaris_smp library
	$(MAKE) -C ../../../system/brahma at_solaris_smp INSTALL=lib/at_solaris_smp.a ARCH=i386-solaris

clean:
test:
